<template>
  <q-container>
    <div class="row q-pa-lg">
      <div class="col text-left text-dark">
        <q-btn
          unelevated
          text
          label="BACK"
          class="btn-md btn-back"
          icon="arrow_back"
          @click="goBack()"
        />
      </div>
    </div>

    <div class="row q-px-xl">
      <div class="col">
        <span class="title-2 text-left text-green-10">{{
          jobDetail.job_title
        }}</span>
      </div>
    </div>

    <div class="row q-pa-lg q-mx-xl">
      <div class="col">
        <div class="row">
          <div class="col-3">
            <p class="title-small text-left text-grey-7">JOB ID NO.</p>
            <p class="title-small text-left text-grey-7">POSTED ON</p>
            <p class="title-small text-left text-grey-7">STATUS</p>

            <archive-menu
              v-if="
                jobDetail.is_archived === false &&
                jobDetail.status !== 'pending'
              "
              @dialog:show="showDialogComponent($event)"
            />
          </div>

          <div class="col">
            <p class="title-6 text-left text-dark">
              {{ jobDetail.job_id }}
            </p>
            <p class="title-6 text-left text-dark">
              {{ formatDate(jobDetail.created_at, "MM/DD/YYYY") }}
            </p>
            <p
              v-if="
                jobDetail.status === 'approved' &&
                jobDetail.is_archived === false
              "
              class="title-6 text-left text-dark"
            >
              Active
            </p>

            <p
              v-else-if="
                jobDetail.status === 'pending' &&
                jobDetail.is_archived === false
              "
              class="title-6 text-left text-dark"
            >
              Pending
            </p>

            <p v-else class="title-6 text-left text-dark">Archived</p>
          </div>
        </div>
      </div>

      <div class="col-8">
        <div class="row">
          <div class="col-2">
            <p class="title-small text-left text-grey-7">DESCRIPTION</p>
          </div>

          <div class="col">
            <p
              class="title-6 text-left text-dark"
              v-html="jobDetail.job_description"
            ></p>
          </div>
        </div>
      </div>
    </div>

    <q-table
      :rows="jobStore.applications"
      :columns="columns"
      row-key="name"
      class="table q-mx-xl"
      table-style="border-radius: 10px; background-color: white;"
      :loading="jobStore.jobLoading"
    >
      <template v-slot:body-cell-reference_no="props">
        <q-td :props="props">
          {{ props.row.id }}
        </q-td>
      </template>

      <template v-slot:body-cell-first_name="props">
        <q-td :props="props">
          {{ props.row.user.first_name ? props.row.user.first_name : "-" }}
        </q-td>
      </template>

      <template v-slot:body-cell-last_name="props">
        <q-td :props="props">
          {{ props.row.user.last_name ? props.row.user.last_name : "-" }}
        </q-td>
      </template>

      <template v-slot:body-cell-gender="props">
        <q-td v-if="props.row.user.gender === 'male'" :props="props">
          Male
        </q-td>

        <q-td v-else-if="props.row.user.gender === 'female'" :props="props">
          Female
        </q-td>

        <q-td v-else :props="props"> - </q-td>
      </template>

      <template v-slot:body-cell-age="props">
        <q-td :props="props">
          {{ props.row.user.age }}
        </q-td>
      </template>

      <template v-slot:body-cell-barangay="props">
        <q-td :props="props">
          {{ props.row.user.address ? props.row.user.address : "-" }}
        </q-td>
      </template>

      <template v-slot:body-cell-status="props">
        <q-td :props="props">
          <q-badge class="q-ml-sm q-pa-xs text-dark" color="grey-3">{{
            props.row.application_status.name
          }}</q-badge>
        </q-td>
      </template>

      <template v-slot:header-cell-actions="props">
        <q-th :props="props">
          <div class="title-xsmall text-grey-7">
            {{
              jobStore.applications.length > 1
                ? jobStore.applications.length + " APPLICANTS"
                : jobStore.applications.length + " APPLICANT"
            }}
          </div>
        </q-th>
      </template>

      <template v-slot:body-cell-actions="props">
        <q-td :props="props">
          <div>
            <q-btn
              unelevated
              label="VIEW"
              class="btn-lg bg-positive text-white"
              @click="
                fetchApplicantdetails(
                  props.row.id,
                  props.row.application_status_id
                )
              "
            />
          </div>
        </q-td>
      </template>
    </q-table>
  </q-container>

  <!-- DIALOG: VIEW APPLICANT DETAILS -->
  <q-dialog
    v-model="showApplicantDetailDialog"
    persistent
    @hide="showApplicantDetailDialog === false"
  >
    <q-card
      flat
      class="q-pa-xs q-mt-lg rounded-borders-10"
      style="width: 1500px; max-width: 100vw; height: 776px"
    >
      <q-form>
        <q-card-section class="row items-center q-pb-none">
          <q-space />
          <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
        </q-card-section>

        <div class="q-px-lg">
          <q-card-section class="row items-center q-py-none">
            <!-- <q-avatar class="q-mr-md">
              <img src="~assets/default.png" />
            </q-avatar> -->
            <custom-avatar
              v-if="applicationStore.applicant"
              class="q-mr-md"
              :photoUrl="applicationStore.applicant.profile_picture_url"
              :name="applicationStore.applicant.first_name"
              :userType="applicationStore.applicant.user_type"
              fontSize="17px"
              size="60px"
              shadow="shadow-5"
            />
            <div class="text">
              <div class="text-title">
                {{
                  applicationStore.applicant.first_name +
                  " " +
                  applicationStore.applicant.last_name
                }}
              </div>
              <div class="text-subtitle"></div>
            </div>
            <q-spacer />
          </q-card-section>

          <q-card-section>
            <div class="row q-my-sm">
              <div class="col">
                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      FIRST NAME
                    </label>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">
                      {{
                        applicationStore.applicant.first_name
                          ? applicationStore.applicant.first_name
                          : "-"
                      }}
                    </p>
                  </div>
                </div>

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      LAST NAME
                    </label>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">
                      {{
                        applicationStore.applicant.last_name
                          ? applicationStore.applicant.last_name
                          : "-"
                      }}
                    </p>
                  </div>
                </div>

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      MIDDLE NAME
                    </label>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">
                      {{
                        applicationStore.applicant.middle_name
                          ? applicationStore.applicant.middle_name
                          : "-"
                      }}
                    </p>
                  </div>
                </div>

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      EMAIL
                    </label>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">
                      {{
                        applicationStore.applicant.email
                          ? applicationStore.applicant.email
                          : "-"
                      }}
                    </p>
                  </div>
                </div>

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      MOBILE NUMBER
                    </label>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">
                      {{
                        applicationStore.applicant.mobile_number
                          ? applicationStore.applicant.mobile_number
                          : "-"
                      }}
                    </p>
                  </div>
                </div>

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      BIRTHDATE
                    </label>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">
                      {{
                        applicationStore.applicant.birthdate
                          ? applicationStore.applicant.birthdate
                          : "-"
                      }}
                    </p>
                  </div>
                </div>

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      ADDRESS (BRGY)
                    </label>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">
                      {{
                        applicationStore.applicant.address
                          ? applicationStore.applicant.address.barangay.name
                          : "-"
                      }}
                    </p>
                  </div>
                </div>

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      ADDRESS (CITY)
                    </label>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">
                      {{
                        applicationStore.applicant.address
                          ? applicationStore.applicant.address.city.name
                          : "-"
                      }}
                    </p>
                  </div>
                </div>

                <br />

                <div
                  class="row"
                  v-for="(education, k) in applicationStore.applicant
                    .job_seeker_educations"
                  :key="k"
                >
                  <div class="col-5 text-grey-7">
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      SCHOOL
                    </p>
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-md"
                      style="font-size: 11px"
                    >
                      YEAR
                    </p>
                    <p
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      LEVEL
                    </p>
                  </div>

                  <div class="col text-dark">
                    <p class="title-6">{{ education.school_name }}</p>
                    <p class="title-6">
                      {{ education.year_from + " - " + education.year_to }}
                    </p>
                    <p class="title-6">
                      {{ getEducationLevels(education.education_level_id) }}
                    </p>
                  </div>
                </div>

                <br />

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      CV / RESUME
                    </label>
                  </div>

                  <div class="col">
                    <div class="row q-mb-sm">
                      <div class="col">
                        <q-btn
                          id="view"
                          unelevated
                          label="VIEW"
                          block
                          class="bg-green-10 btn-lg text-white"
                          @click="
                            openFile(
                              applicationStore.applicant.cv_or_resume_url
                            )
                          "
                        />
                      </div>
                    </div>

                    <div class="row">
                      <div class="col">
                        <q-btn
                          id="download"
                          unelevated
                          block
                          label="DOWNLOAD"
                          class="bg-green-10 btn-lg text-white"
                          @click="
                            downloadFile(
                              applicationStore.applicant.cv_or_resume_url,
                              applicationStore.applicant.cv_or_resume
                            )
                          "
                        />
                      </div>
                    </div>
                  </div>
                </div>

                <br />

                <div class="row">
                  <div class="col-5 text-grey-7 q-mt-xs">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      INTERVIEW AVAILABILITY
                    </label>
                  </div>

                  <div
                    class="col text-dark q-mt-xs"
                    v-for="(
                      availability, k
                    ) in jobStore.jobDetail.applications.filter(
                      (item) => item.id === applicationStore.application.id
                    )"
                    :key="k"
                  >
                    <span v-if="availability.monday === true">Mon, </span>
                    <span v-if="availability.tuesday === true">Tue, </span>
                    <span v-if="availability.wednesday === true">Wed, </span>
                    <span v-if="availability.thursday === true">Thu, </span>
                    <span v-if="availability.friday === true">Fri</span>

                    <span v-if="availability.am || availability.pm"> - </span>

                    <span v-if="availability.am === true">AM,</span>
                    <span v-if="availability.pm === true">PM</span>
                  </div>
                </div>
              </div>

              <div class="col-4 q-mx-xl">
                <div class="row">
                  <div class="col-4 text-grey-7">
                    <label
                      class="text-caption text-weight-bold text-grey-7"
                      style="font-size: 11px"
                    >
                      SKILLS
                    </label>
                  </div>
                </div>

                <div class="row">
                  <div
                    class="col-4 text-dark"
                    v-for="(skill, k) in applicationStore.applicant
                      .job_seeker_skills"
                    :key="k"
                  >
                    <ul>
                      <li class="title-6">{{ skill.skill.name }}</li>
                    </ul>
                  </div>
                </div>

                <br />
                <br />

                <div
                  class="row q-mb-md"
                  v-for="(work, k) in applicationStore.applicant.work_histories"
                  :key="k"
                >
                  <div class="col-5 text-grey-7">
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      COMPANY
                    </p>
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      TITLE
                    </p>
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      EMPLOYMENT DATES
                    </p>
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      COE
                    </p>
                  </div>

                  <div class="col text-dark">
                    <p>{{ work.company_name }}</p>
                    <p>{{ work.title }}</p>
                    <p>{{ work.date_from + " - " + work.date_to }}</p>
                    <a
                      :href="work.certificate_of_employment_url"
                      target="_blank"
                    >
                      <p style="overflow: hidden; text-overflow: ellipsis">
                        {{ work.certificate_of_employment }}
                      </p>
                    </a>
                  </div>
                </div>

                <br />

                <div
                  class="row q-mb-md"
                  v-for="(reference, k) in applicationStore.applicant
                    .character_references"
                  :key="k"
                >
                  <div class="col-5 text-grey-7">
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      REFERENCE NAME
                    </p>
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      CONTACT NUMBER
                    </p>
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      EMAIL ADDRESS
                    </p>
                  </div>

                  <div class="col text-dark">
                    <p>{{ reference.contact_name }}</p>
                    <p>{{ reference.contact_number }}</p>
                    <p>{{ reference.email }}</p>
                  </div>
                </div>

                <br />

                <div
                  class="row q-mb-md"
                  v-for="(training, k) in applicationStore.applicant
                    .job_seeker_certificates"
                  :key="k"
                >
                  <div class="col-5 text-grey-7">
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      TRAINING NAME
                    </p>
                    <p
                      class="text-caption text-weight-bold text-grey-7 q-mt-xs"
                      style="font-size: 11px"
                    >
                      CERTIFICATE
                    </p>
                  </div>

                  <div class="col text-dark">
                    <p>{{ training.training_name }}</p>
                    <a :href="training.certificate_url" target="_blank">
                      <p style="overflow: hidden; text-overflow: ellipsis">
                        {{ training.certificate }}
                      </p>
                    </a>
                  </div>
                </div>
              </div>

              <div class="col">
                <div class="row q-mb-sm">
                  <label
                    class="text-caption text-weight-bold text-grey-7"
                    style="font-size: 11px"
                  >
                    SEND A MESSAGE
                  </label>
                </div>
                <div class="row q-mb-lg">
                  <div class="col" align="center">
                    <q-btn
                      unelevated
                      label="GO TO MESSAGES"
                      class="btn-lg bg-positive text-white"
                      @click="
                        redirectToMessages(applicationStore.application.id)
                      "
                    />
                  </div>
                </div>
                <div
                  v-if="
                    applicationForm.application_status !== 'Hired' &&
                    applicationForm.application_status !== 'Rejected'
                  "
                  class="row q-mb-sm"
                >
                  <label
                    class="text-caption text-weight-bold text-grey-7"
                    style="font-size: 11px"
                  >
                    SET APPLICATION STATUS
                  </label>
                </div>

                <!-- <div
                  v-if="
                    applicationForm.application_status === 'Hired' ||
                    applicationForm.application_status === 'Rejected' ||
                    showEditor
                  "
                  class="row q-ml-lg"
                >
                  <div class="col-12">
                    <q-editor
                      ref="textEditor"
                      v-model.trim="form.message"
                      @update:model-value="messageDidUpdate()"
                      min-height="2rem"
                      min-width="100%"
                      :dense="$q.screen.lt.md"
                      :toolbar="[]"
                      placeholder="Enter your message here..."
                      @keydown.enter.prevent="sendMessage(form)"
                    />

                    <div class="row q-mt-md" style="padding: 0 0 10px 0">
                      <div
                        class="col-8"
                        align="left"
                        style="padding: 10px 0 0 10px"
                      >
                        <span
                          class="text-negative text-left"
                          style="font-size: 12px; font-weight: 600"
                        >
                          {{ errorMessage }}
                        </span>
                      </div>
                      <div class="col-4" align="right" style="padding: 0">
                        <div class="row" style="padding: 0">
                          <div class="col" align="center">
                            <q-btn
                              v-show="!isApplicationDone"
                              unelevated
                              outline
                              class="btn-md"
                              label="CANCEL"
                              color="dark-blue"
                              style="width: 80%"
                              @click="hideMessageEditor()"
                            />
                          </div>

                          <div class="col" align="center">
                            <q-btn
                              unelevated
                              class="btn-md"
                              label="SEND"
                              style="width: 80%"
                              color="dark-blue"
                              @click="sendMessage(form)"
                              :loading="loading"
                            />
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div> -->

                <div
                  v-if="
                    applicationForm.application_status !== 'Hired' &&
                    applicationForm.application_status !== 'Rejected'
                  "
                  class="row q-ml-lg"
                >
                  <div class="col-12">
                    <div class="text-grey-7 q-pa-0">
                      <label
                        class="text-caption text-weight-bold text-grey-7"
                        style="font-size: 11px"
                        >STATUS<span class="text-negative">*</span></label
                      >
                      <q-select
                        v-model="form.application_status_id"
                        @update:model-value="formatMessage(form, true)"
                        :rules="[validations.requiredField]"
                        class="q-mt-sm"
                        outlined
                        :options="getStatusList"
                        map-options
                        emit-value
                        dense
                        block
                      />
                    </div>

                    <div
                      v-if="
                        form.application_status_id &&
                        form.application_status_id === 3
                      "
                      class="text-grey-7 q-pa-0"
                    >
                      <label
                        class="text-caption text-weight-bold text-grey-7"
                        style="font-size: 11px"
                        >MEETING LINK<span class="text-negative">*</span></label
                      >
                      <q-input
                        v-model="form.meeting_link"
                        dense
                        outlined
                        class="q-mt-sm"
                        :rules="[validations.requiredField]"
                        @update:model-value="formatMessage(form, false)"
                      />
                    </div>

                    <div
                      v-if="
                        form.application_status_id &&
                        (form.application_status_id === 2 ||
                          form.application_status_id === 4)
                      "
                      class="text-grey-7 q-pa-0"
                    >
                      <label
                        class="text-caption text-weight-bold text-grey-7"
                        style="font-size: 11px"
                        >OFFICE ADDRESS<span class="text-negative"
                          >*</span
                        ></label
                      >
                      <q-input
                        v-model="form.office_address"
                        dense
                        outlined
                        class="q-mt-sm"
                        :rules="[validations.requiredField]"
                        @update:model-value="formatMessage(form, false)"
                      />
                    </div>

                    <div
                      v-if="
                        form.application_status_id &&
                        (form.application_status_id === 2 ||
                          form.application_status_id === 4)
                      "
                      class="text-grey-7 q-pa-0 q-mb-md"
                    >
                      <label
                        class="text-caption text-weight-bold text-grey-7"
                        style="font-size: 11px"
                        >DATE & TIME<span class="text-negative">*</span></label
                      >
                      <q-input
                        dense
                        outlined
                        class="q-mt-sm"
                        v-model="form.datetime"
                      >
                        <template v-slot:prepend>
                          <q-icon
                            name="eva-calendar-outline"
                            class="cursor-pointer"
                          >
                            <q-popup-proxy
                              cover
                              transition-show="scale"
                              transition-hide="scale"
                            >
                              <q-date
                                v-model="form.datetime"
                                mask="MM/DD/YYYY hh:mm A"
                                :rules="[validations.requiredField]"
                                :options="
                                  (date) =>
                                    date >= formatDate(Date.now(), 'YYYY/MM/DD')
                                "
                                @update:model-value="formatMessage(form, false)"
                              >
                                <div class="row items-center justify-end">
                                  <q-btn
                                    v-close-popup
                                    label="Close"
                                    color="primary"
                                    flat
                                  />
                                </div>
                              </q-date>
                            </q-popup-proxy>
                          </q-icon>
                        </template>

                        <template v-slot:append>
                          <q-icon
                            name="eva-clock-outline"
                            class="cursor-pointer"
                          >
                            <q-popup-proxy
                              cover
                              transition-show="scale"
                              transition-hide="scale"
                            >
                              <q-time
                                v-model="form.datetime"
                                mask="MM/DD/YYYY hh:mm A"
                                @update:model-value="formatMessage(form, false)"
                              >
                                <div class="row items-center justify-end">
                                  <q-btn
                                    v-close-popup
                                    label="Close"
                                    color="primary"
                                    flat
                                  />
                                </div>
                              </q-time>
                            </q-popup-proxy>
                          </q-icon>
                        </template>
                      </q-input>
                    </div>
                  </div>

                  <!-- <div
                    v-show="!form.application_status_id"
                    class="col-12 q-mt-lg"
                    style="
                      display: flex;
                      justify-content: center;
                      align-items: center;
                    "
                  >
                    <div class="col text-grey-7" align="center">
                      <span>--- OR ---</span>
                    </div>
                  </div>

                  <div
                    v-show="!form.application_status_id"
                    class="col-12 q-mt-lg"
                    style="
                      display: flex;
                      justify-content: center;
                      align-items: center;
                    "
                  >
                    <div class="col" align="center">
                      <q-btn
                        unelevated
                        label="SEND A MESSAGE"
                        class="btn--shade-2 btn-md text-white"
                        style="width: 50%"
                        @click="showMessageEditor()"
                      />
                    </div>
                  </div> -->

                  <div v-show="form.application_status_id" class="col-12">
                    <div class="col text-grey-7">
                      <label
                        class="text-caption text-weight-bold text-grey-7"
                        style="font-size: 11px"
                        >MESSAGE PREVIEW</label
                      >
                      <q-input
                        v-model="form.message"
                        outlined
                        class="q-mt-sm"
                        type="textarea"
                      />
                    </div>

                    <div
                      v-if="form.application_status_id"
                      style="
                        display: flex;
                        justify-content: center;
                        align-items: center;
                      "
                      class="q-mt-md"
                    >
                      <div class="col" align="center">
                        <q-btn
                          unelevated
                          outline
                          class="btn-md q-ml-md"
                          label="CANCEL"
                          color="green-10"
                          style="width: 70%"
                          @click="cancelStatus()"
                          :loading="loading"
                        />
                      </div>

                      <div class="col" align="center">
                        <q-btn
                          unelevated
                          class="btn-md q-mr-md"
                          label="SEND"
                          color="green-10"
                          style="width: 70%"
                          @click="updateStatus(applicationForm.id, form)"
                          :loading="loading"
                        />
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </q-card-section>
        </div>
      </q-form>
    </q-card>
  </q-dialog>

  <!-- DIALOG: ARCHIVE JOB -->
  <q-dialog
    v-model="showArchiveJobDialog"
    persistent
    @hide="showArchiveJobDialog === false"
  >
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 600px; max-width: 80vw"
    >
      <q-card-section class="row items-center q-pb-none">
        <span class="title-headline text-dark">Archive Job Post</span>
        <q-space />
        <q-btn size="md" icon="eva-close" flat round dense v-close-popup />
      </q-card-section>

      <q-card-section class="q-pt-none">
        Are you sure you want to archive job post ID#
        {{ jobStore.jobDetail.id }}?
      </q-card-section>

      <div class="q-mt-md" align="center">
        <q-btn
          unelevated
          no-caps
          label="Archive"
          class="btn-md bg-negative text-white q-mb-sm"
          :loading="loading"
          @click="confirmArchive(jobStore.jobDetail.id)"
        />
      </div>
    </q-card>
  </q-dialog>
</template>

<script>
import { defineComponent, ref, reactive, computed } from "vue";
import { useJob } from "../store/job";
import { useRoom } from "src/modules/messages-employer/store/room";
// import { useApplication } from "../store/application";
import { useApplication } from "src/modules/messages/store/application";
// import { useReference } from "../store/reference";
import { useReference } from "src/modules/auth/store/reference";
import { TABLES } from "../constants";
import { LocalStorage } from "quasar";
import { EmployerApplicationApi } from "src/hooks/api";
import { requiredField } from "src/hooks/validations";
import { date } from "quasar";
import useApplicationHook from "../hooks/applicationHook";
import useJobHook from "../hooks/jobHook";
import ArchiveMenu from "../components/partials/ArchiveMenu.vue";
import downloadjs from "downloadjs";
import dayjs from "dayjs";
import usePageRouter from "src/hooks/pageRouter";
import { useEmployer } from "src/layouts/portals/store/employer";
import CustomAvatar from "src/components/CustomAvatar.vue";

export default defineComponent({
  components: {
    ArchiveMenu,
    CustomAvatar,
  },

  setup() {
    const jobStore = useJob();
    const { showJobDetails } = jobStore;

    const applicationStore = useApplication();
    const { showApplication } = applicationStore;

    const referenceStore = useReference();
    const { getLevels } = referenceStore;

    const roomStore = useRoom();

    const { router } = usePageRouter();

    const employerStore = useEmployer();
    const { getNotificationCount } = employerStore;

    const showDialogComponent = (event) => {
      if (event === "filled") {
        archiveForm.archive_status = "filled";
        showArchiveJobDialog.value = true;
      }

      if (event === "deactivated_without_hiring") {
        archiveForm.archive_status = "deactivated_without_hiring";
        showArchiveJobDialog.value = true;
      }
    };

    const { loading, doUpdateApplicationStatus } = useApplicationHook();
    const { doArchiveJobPost } = useJobHook();

    const isError = ref(false);
    const errorMessage = ref("");
    const showApplicantDetailDialog = ref(false);
    const showArchiveJobDialog = ref(false);
    const showEditor = ref(false);
    const JOB_ID = ref(null);

    const statusOptions = ref([
      {
        label: "Pending",
        value: 1,
      },
      {
        label: "1st Interview Pending",
        value: 2,
      },
      {
        label: "1st Interview Confirmed",
        value: 3,
      },
      {
        label: "2nd Interview Pending",
        value: 4,
      },
      {
        label: "2nd Interview Confirmed",
        value: 5,
      },
      {
        label: "Hired",
        value: 6,
      },
      {
        label: "Rejected",
        value: 7,
      },
    ]);

    const form = reactive({
      application_status_id: null,
      datetime: null,
      office_address: null,
      meeting_link: null,
      phone_or_email: null,
      message: "",
    });

    const applicationForm = reactive({
      id: null,
      application_status: null,
      cover_letter: null,
      cv_or_resume_url: null,
      job_post_id: null,
    });

    const jobDetail = reactive({
      job_id: null,
      job_title: null,
      job_description: null,
      created_at: null,
      status: null,
      is_archived: null,
    });

    const archiveForm = reactive({
      is_archived: false,
      archive_status: null,
    });

    const goBack = () => {
      window.history.back();
    };

    const formatDate = (date, format) => {
      return dayjs(date).format(format);
    };

    const openFile = (url) => {
      window.open(url);
    };

    const downloadFile = (url, filename) => {
      var x = new XMLHttpRequest();
      x.open("GET", url, true);
      x.responseType = "blob";
      x.onload = function (e) {
        downloadjs(e.target.response, filename);
      };
      x.send();
    };

    const getEducationLevels = (id) => {
      for (let x = 0; x < referenceStore.levels.length; x++) {
        const level = referenceStore.levels[x];

        if (level.id === id) {
          return level.name;
        }
      }
    };

    const fetchData = async () => {
      JOB_ID.value = LocalStorage.getItem("job_id");
      await showJobDetails(JOB_ID.value).then(() => {
        console.log("Need to refresh? ", employerStore.needToRefresh);

        if (employerStore.needToRefresh) {
          getNotificationCount();
        }

        jobDetail.job_id = jobStore.jobDetail.id;
        jobDetail.job_title = jobStore.jobDetail.job_title;
        jobDetail.job_description = jobStore.jobDetail.job_description;
        jobDetail.created_at = jobStore.jobDetail.created_at;
        jobDetail.is_archived = jobStore.jobDetail.is_archived;
        jobDetail.status = jobStore.jobDetail.status;
      });
    };

    const fetchApplicantdetails = async (application_id) => {
      console.log("fetchApplicantdetails: ", application_id);
      form.application_status_id = null;
      form.datetime = null;
      form.office_address = null;
      form.meeting_link = null;
      form.phone_or_email = null;
      form.message = "";

      await showApplication(application_id).then((response) => {
        console.log("response: ", response);
        // if (data.success) {
        applicationForm.id = applicationStore.application.id;
        applicationForm.application_status =
          applicationStore.application.application_status.name;
        applicationForm.cover_letter =
          applicationStore.application.cover_letter;
        applicationForm.cv_or_resume_url =
          applicationStore.application.cv_or_resume_url;
        applicationForm.job_post_id = applicationStore.application.job_post_id;
        // }
        showApplicantDetailDialog.value = true;
      });
    };

    const getStatusList = computed(() => {
      return statusOptions.value.filter(
        (option) => option.value > applicationStore.currentApplicationStatusID
      );
    });

    const showMessageEditor = () => {
      showEditor.value = true;
    };

    const hideMessageEditor = () => {
      showEditor.value = false;
    };

    const cancelStatus = () => {
      form.application_status_id = null;
      form.datetime = null;
      form.office_address = null;
      form.meeting_link = null;
      form.phone_or_email = null;
      form.message = "";
    };

    const updateStatus = async (application_id, form) => {
      await doUpdateApplicationStatus(application_id, form).then((data) => {
        if (data.success) {
          form.application_status_id = null;
          form.datetime = null;
          form.office_address = null;
          form.meeting_link = null;
          form.phone_or_email = null;
          form.message = null;

          showApplication(application_id);

          showApplicantDetailDialog.value = false;
          fetchData();
        }
      });
    };

    const redirectToMessages = (application_id) => {
      let room = roomStore.rooms.find(
        (item) => item.application_id === application_id
      );
      console.log("room: ", room);
      if (room) {
        router.push({
          name: "MessagesDetailPage",
          params: {
            roomid: room.id,
          },
        });
      }
    };

    const formatMessage = (form, fromStatus) => {
      if (fromStatus) {
        form.datetime = null;
        form.office_address = null;
        form.meeting_link = null;
        form.phone_or_email = null;
        form.message = "";
      }
      if (form.application_status_id) {
        switch (form.application_status_id) {
          case 1: // Pending
            break;
          case 2: // 1st Interview Pending
            if (form.datetime)
              form.message = `You have been scheduled for an online interview with the HR Team on ${date.formatDate(
                form.datetime,
                "MMMM DD, YYYY"
              )} at ${date.formatDate(
                form.datetime,
                "hh:mm A"
              )}. Please confirm to get the meeting link. If you have any questions or concerns, you may contact us at phone/email.`;
            break;
          case 3: // 1st Interview Confirmed
            if (form.meeting_link)
              form.message = `Thank you for confirming. Please use this meeting link: ${form.meeting_link}.`;
            break;
          case 4: // 2nd Interview Pending
            if (form.office_address && form.datetime)
              form.message = `Congratulations! You have advanced to the next step. Please come to ${
                form.office_address
              } for the 2nd round of interview on ${date.formatDate(
                form.datetime,
                "MMMM DD, YYYY"
              )} at ${date.formatDate(form.datetime, "hh:mm A")}.`;
            break;
          case 5: // 2nd Interview Confirmed
            form.message =
              "Thank you for confirming. We look forward to meeting with you to discuss your suitability for the role.";
            break;
          case 6: // Hired
            form.message = "Congratulations!";
            break;
          case 7: // Rejected
            form.message =
              "We regret to inform you that you have not been selected for the position you are applying for. Please check other positions and try again. Thank you.";
            break;
        }
      }
    };

    const sendMessage = async (payload) => {
      if (payload.message.length > 0) {
        loading.value = true;
        isError.value = false;
        errorMessage.value = "";

        await EmployerApplicationApi.update(
          applicationStore.application.id,
          payload
        )
          .then((response) => {
            payload.message = "";
            // if (response.data.success) {
            //   if (form.status.length > 0) {
            //     getApplication(applicationStore.selectedApplicationID);
            //   }
            // }
          })
          .catch((error) => {
            isError.value = true;
            errorMessage.value = error?.response?.data?.message.toUpperCase();
          })
          .finally(() => {
            loading.value = false;
          });
      } else {
        errorMessage.value = "THE MESSAGE FIELD IS REQUIRED.";
      }
    };

    const confirmArchive = async (id) => {
      loading.value = true;
      archiveForm.is_archived = true;
      await doArchiveJobPost(id, archiveForm);
      loading.value = false;

      showArchiveJobDialog.value = false;
      fetchData();
    };

    fetchData();
    getLevels();

    return {
      jobStore,
      applicationStore,
      roomStore,
      columns: TABLES.JobDetailsTable.columns,
      showApplicantDetailDialog,
      showArchiveJobDialog,
      form,
      applicationForm,
      jobDetail,
      archiveForm,
      loading,
      getStatusList,
      showEditor,
      isError,
      errorMessage,
      validations: {
        requiredField,
      },
      showDialogComponent,
      goBack,
      fetchApplicantdetails,
      getEducationLevels,
      doUpdateApplicationStatus,
      doArchiveJobPost,
      formatMessage,
      formatDate,
      sendMessage,
      confirmArchive,
      openFile,
      downloadFile,
      redirectToMessages,
      showMessageEditor,
      hideMessageEditor,
      cancelStatus,
      updateStatus,
    };
  },
});
</script>

<style lang="sass">
#view,
#download
  width: 133px !important

p
  margin-bottom: 12px !important


ul
  margin-bottom: 0 !important

.table
  max-height: 70vh

  .q-table__top,
  thead tr:first-child th
    background-color: #E9E9E8

  thead tr th
    position: sticky
    z-index: 1
  thead tr:first-child th
    top: 0

  &.q-table--loading thead tr:last-child th
    top: 48px
</style>

<style lang="scss">
div.q-table__container {
  background: #f1f1f1;
  box-shadow: none;
}
div.q-table__middle::-webkit-scrollbar-track {
  background: #ddd;
}
div.q-table__middle::-webkit-scrollbar {
  display: none;
}
div.q-table__middle {
  -ms-overflow-style: none;
  scrollbar-width: none;
}

div.q-table__bottom {
  border-top: 0;
}

div.q-table__card {
  box-shadow: 0;
}
</style>
